// D import file generated from 'derelict/alure/alure.d'
module derelict.alure.alure;
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "ALURE32.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libalure.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libalure.so, libalure.so.1";
			}
			else
			{
				static assert(0, "Need to implement ALURE libNames for this operating system.");
			}
		}
	}
}
public import derelict.openal.al;
enum ALURE_VERSION_1_2 = true;
alias alureInt64 = long;
struct alureStream;
extern (C) 
{
	alias alureInstallDecodeCallbacks_open_file = void* function(ALchar*);
	alias alureInstallDecodeCallbacks_open_memory = void* function(ALubyte*, ALuint);
	alias alureInstallDecodeCallbacks_get_format = ALboolean function(void*, ALenum*, ALuint*, ALuint*);
	alias alureInstallDecodeCallbacks_decode = ALuint function(void*, ALubyte*, ALuint);
	alias alureInstallDecodeCallbacks_rewind = ALboolean function(void*);
	alias alureInstallDecodeCallbacks_close = void function(void*);
	alias alureCreateStreamFromCallback_callback = ALuint function(void*, ALubyte*, ALuint);
	alias alureSetIOCallbacks_open_callback = void* function(char*, ALuint);
	alias alureSetIOCallbacks_close_callback = void function(char*);
	alias alureSetIOCallbacks_read_callback = ALsizei function(void*, ALubyte*, ALuint);
	alias alureSetIOCallbacks_write_callback = ALsizei function(void*, ALubyte*, ALuint);
	alias alureSetIOCallbacks_seek_callback = alureInt64 function(void*, alureInt64, int);
	alias alurePlaySourceStream_eos_callback = void function(void*, ALuint);
	alias alurePlaySource_callback = void function(void*, ALuint);
}
extern (C) nothrow 
{
	alias da_alureGetVersion = void function(ALuint*, ALuint*);
	alias da_alureGetErrorString = ALchar* function();
	alias da_alureGetDeviceNames = ALCchar** function(ALCboolean all, ALCsizei*);
	alias da_alureFreeDeviceNames = void function(ALCchar**);
	alias da_alureInitDevice = ALCboolean function(ALCchar*, ALCint*);
	alias da_alureShutdownDevice = ALCboolean function();
	alias da_alureGetSampleFormat = ALenum function(ALuint, ALuint, ALuint);
	alias da_alureInstallDecodeCallbacks = ALboolean function(ALint, alureInstallDecodeCallbacks_open_file, alureInstallDecodeCallbacks_open_memory, alureInstallDecodeCallbacks_get_format, alureInstallDecodeCallbacks_decode, alureInstallDecodeCallbacks_rewind, alureInstallDecodeCallbacks_close);
	alias da_alureSleep = ALboolean function(ALfloat);
	alias da_alureGetProcAddress = void* function(ALchar*);
	alias da_alureCreateBufferFromFile = ALuint function(ALchar*);
	alias da_alureCreateBufferFromMemory = ALuint function(ALubyte*, ALsizei);
	alias da_alureBufferDataFromFile = ALboolean function(ALchar*, ALuint);
	alias da_alureBufferDataFromMemory = ALboolean function(ALubyte*, ALsizei, ALuint);
	alias da_alureStreamSizeIsMicroSec = ALboolean function(ALboolean);
	alias da_alureCreateStreamFromFile = alureStream* function(ALchar*, ALsizei, ALsizei, ALuint*);
	alias da_alureCreateStreamFromMemory = alureStream* function(ALubyte*, ALuint, ALsizei, ALsizei, ALuint*);
	alias da_alureCreateStreamFromStaticMemory = alureStream* function(ALubyte*, ALuint, ALsizei, ALsizei, ALuint*);
	alias da_alureCreateStreamFromCallback = alureStream* function(alureCreateStreamFromCallback_callback, void*, ALenum, ALuint, ALsizei, ALsizei, ALuint*);
	alias da_alureGetStreamFrequency = ALsizei function(alureStream*);
	alias da_alureBufferDataFromStream = ALsizei function(alureStream*, ALsizei, ALuint*);
	alias da_alureRewindStream = ALboolean function(alureStream*, ALsizei);
	alias da_alureSetStreamOrder = ALboolean function(alureStream*, ALuint);
	alias da_alureSetStreamPatchset = ALboolean function(alureStream*, ALchar*);
	alias da_alureGetStreamLength = alureInt64 function(alureStream*);
	alias da_alureDestroyStream = ALboolean function(alureStream*, ALsizei, ALuint*);
	alias da_alureSetIOCallbacks = ALboolean function(alureSetIOCallbacks_open_callback, alureSetIOCallbacks_close_callback, alureSetIOCallbacks_read_callback, alureSetIOCallbacks_write_callback, alureSetIOCallbacks_seek_callback);
	alias da_alurePlaySourceStream = ALboolean function(ALuint, alureStream*, ALsizei, ALsizei, alurePlaySourceStream_eos_callback, void*);
	alias da_alurePlaySource = ALboolean function(ALuint, alurePlaySource_callback, void*);
	alias da_alureStopSource = ALboolean function(ALuint, ALboolean);
	alias da_alurePauseSource = ALboolean function(ALuint);
	alias da_alureResumeSource = ALboolean function(ALuint);
	alias da_alureUpdate = void function();
	alias da_alureUpdateInterval = ALboolean function(ALfloat);
}
__gshared 
{
	da_alureGetVersion alureGetVersion;
	da_alureGetErrorString alureGetErrorString;
	da_alureGetDeviceNames alureGetDeviceNames;
	da_alureFreeDeviceNames alureFreeDeviceNames;
	da_alureInitDevice alureInitDevice;
	da_alureShutdownDevice alureShutdownDevice;
	da_alureGetSampleFormat alureGetSampleFormat;
	da_alureInstallDecodeCallbacks alureInstallDecodeCallbacks;
	da_alureSleep alureSleep;
	da_alureGetProcAddress alureGetProcAddress;
	da_alureCreateBufferFromFile alureCreateBufferFromFile;
	da_alureCreateBufferFromMemory alureCreateBufferFromMemory;
	da_alureBufferDataFromFile alureBufferDataFromFile;
	da_alureBufferDataFromMemory alureBufferDataFromMemory;
	da_alureStreamSizeIsMicroSec alureStreamSizeIsMicroSec;
	da_alureCreateStreamFromFile alureCreateStreamFromFile;
	da_alureCreateStreamFromMemory alureCreateStreamFromMemory;
	da_alureCreateStreamFromStaticMemory alureCreateStreamFromStaticMemory;
	da_alureCreateStreamFromCallback alureCreateStreamFromCallback;
	da_alureGetStreamFrequency alureGetStreamFrequency;
	da_alureBufferDataFromStream alureBufferDataFromStream;
	da_alureRewindStream alureRewindStream;
	da_alureSetStreamOrder alureSetStreamOrder;
	da_alureSetStreamPatchset alureSetStreamPatchset;
	da_alureGetStreamLength alureGetStreamLength;
	da_alureDestroyStream alureDestroyStream;
	da_alureSetIOCallbacks alureSetIOCallbacks;
	da_alurePlaySourceStream alurePlaySourceStream;
	da_alurePlaySource alurePlaySource;
	da_alureStopSource alureStopSource;
	da_alurePauseSource alurePauseSource;
	da_alureResumeSource alureResumeSource;
	da_alureUpdate alureUpdate;
	da_alureUpdateInterval alureUpdateInterval;
}
class DerelictALURELoader : SharedLibLoader
{
	protected override void loadSymbols();
	public this();
}
__gshared DerelictALURELoader DerelictALURE;
shared static this();
